;;; system tick


;; tick counter

.set ticks = heap
.set heap = heap + 2


;; initialize timer0

timer_init:
  ; clear ticks
  out_ ticks,zero
  out_ ticks+1,zero
  
  ; compare of 250 -> 1ms interrupt period
  ldi temp0,250
  out_ OCR0A,temp0

  ; output compare interrupt
  ldi temp0,(1<<OCIE0A)
  out_ TIMSK0,temp0

  ; timer0 clear timer on compare, prescaler at /64
  ldi temp0,(1<<WGM01)|(1<<CS01)|(1<<CS00)
  out_ TCCR0A,temp0
  ret


;; ticks
;;
;; ( -- x )
;;
;; fetch tick counter

link_
.db "ticks",0

tickss:
  dup_
  cli
  in_ tosl,ticks
  in_ tosh,ticks+1
  sei
  ret


;; timer0 isr

.set pc_ = pc
.org TIMER0_COMP
  rjmp timer0_compare
.org pc_

timer0_compare:
  push xl
  in_ xl,SREG
  push xl
  push xh

  in_ xl,ticks
  in_ xh,ticks+1
  adiw x,1
  out_ ticks,xl
  out_ ticks+1,xh

  pop xh
  pop xl,
  out_ SREG,xl
  pop xl
  reti

